/* (c) https://github.com/MontiCore/monticore */
// Generated by the protocol buffer compiler.  DO NOT EDIT!
// source: simulationController.proto

package protobuf;

/**
 * Protobuf type {@code SimulationController.VehicleSimulationDataFrame}
 */
public  final class VehicleSimulationDataFrame extends
    com.google.protobuf.GeneratedMessageV3 implements
    // @@protoc_insertion_point(message_implements:SimulationController.VehicleSimulationDataFrame)
    VehicleSimulationDataFrameOrBuilder {
private static final long serialVersionUID = 0L;
  // Use VehicleSimulationDataFrame.newBuilder() to construct.
  private VehicleSimulationDataFrame(com.google.protobuf.GeneratedMessageV3.Builder<?> builder) {
    super(builder);
  }
  private VehicleSimulationDataFrame() {
    vehicleID_ = "";
    plannedTrajectory_ = java.util.Collections.emptyList();
    frames_ = java.util.Collections.emptyList();
  }

  @java.lang.Override
  public final com.google.protobuf.UnknownFieldSet
  getUnknownFields() {
    return this.unknownFields;
  }
  private VehicleSimulationDataFrame(
      com.google.protobuf.CodedInputStream input,
      com.google.protobuf.ExtensionRegistryLite extensionRegistry)
      throws com.google.protobuf.InvalidProtocolBufferException {
    this();
    if (extensionRegistry == null) {
      throw new java.lang.NullPointerException();
    }
    int mutable_bitField0_ = 0;
    com.google.protobuf.UnknownFieldSet.Builder unknownFields =
        com.google.protobuf.UnknownFieldSet.newBuilder();
    try {
      boolean done = false;
      while (!done) {
        int tag = input.readTag();
        switch (tag) {
          case 0:
            done = true;
            break;
          default: {
            if (!parseUnknownFieldProto3(
                input, unknownFields, extensionRegistry, tag)) {
              done = true;
            }
            break;
          }
          case 10: {
            java.lang.String s = input.readStringRequireUtf8();

            vehicleID_ = s;
            break;
          }
          case 18: {
            if (!((mutable_bitField0_ & 0x00000002) == 0x00000002)) {
              plannedTrajectory_ = new java.util.ArrayList<protobuf.PlannedTrajectory>();
              mutable_bitField0_ |= 0x00000002;
            }
            plannedTrajectory_.add(
                input.readMessage(protobuf.PlannedTrajectory.parser(), extensionRegistry));
            break;
          }
          case 26: {
            if (!((mutable_bitField0_ & 0x00000004) == 0x00000004)) {
              frames_ = new java.util.ArrayList<protobuf.SimulationDataFrame>();
              mutable_bitField0_ |= 0x00000004;
            }
            frames_.add(
                input.readMessage(protobuf.SimulationDataFrame.parser(), extensionRegistry));
            break;
          }
        }
      }
    } catch (com.google.protobuf.InvalidProtocolBufferException e) {
      throw e.setUnfinishedMessage(this);
    } catch (java.io.IOException e) {
      throw new com.google.protobuf.InvalidProtocolBufferException(
          e).setUnfinishedMessage(this);
    } finally {
      if (((mutable_bitField0_ & 0x00000002) == 0x00000002)) {
        plannedTrajectory_ = java.util.Collections.unmodifiableList(plannedTrajectory_);
      }
      if (((mutable_bitField0_ & 0x00000004) == 0x00000004)) {
        frames_ = java.util.Collections.unmodifiableList(frames_);
      }
      this.unknownFields = unknownFields.build();
      makeExtensionsImmutable();
    }
  }
  public static final com.google.protobuf.Descriptors.Descriptor
      getDescriptor() {
    return protobuf.SimulationControllerProto.internal_static_SimulationController_VehicleSimulationDataFrame_descriptor;
  }

  protected com.google.protobuf.GeneratedMessageV3.FieldAccessorTable
      internalGetFieldAccessorTable() {
    return protobuf.SimulationControllerProto.internal_static_SimulationController_VehicleSimulationDataFrame_fieldAccessorTable
        .ensureFieldAccessorsInitialized(
            protobuf.VehicleSimulationDataFrame.class, protobuf.VehicleSimulationDataFrame.Builder.class);
  }

  private int bitField0_;
  public static final int VEHICLEID_FIELD_NUMBER = 1;
  private volatile java.lang.Object vehicleID_;
  /**
   * <code>string vehicleID = 1;</code>
   */
  public java.lang.String getVehicleID() {
    java.lang.Object ref = vehicleID_;
    if (ref instanceof java.lang.String) {
      return (java.lang.String) ref;
    } else {
      com.google.protobuf.ByteString bs = 
          (com.google.protobuf.ByteString) ref;
      java.lang.String s = bs.toStringUtf8();
      vehicleID_ = s;
      return s;
    }
  }
  /**
   * <code>string vehicleID = 1;</code>
   */
  public com.google.protobuf.ByteString
      getVehicleIDBytes() {
    java.lang.Object ref = vehicleID_;
    if (ref instanceof java.lang.String) {
      com.google.protobuf.ByteString b = 
          com.google.protobuf.ByteString.copyFromUtf8(
              (java.lang.String) ref);
      vehicleID_ = b;
      return b;
    } else {
      return (com.google.protobuf.ByteString) ref;
    }
  }

  public static final int PLANNEDTRAJECTORY_FIELD_NUMBER = 2;
  private java.util.List<protobuf.PlannedTrajectory> plannedTrajectory_;
  /**
   * <code>repeated .SimulationController.PlannedTrajectory plannedTrajectory = 2;</code>
   */
  public java.util.List<protobuf.PlannedTrajectory> getPlannedTrajectoryList() {
    return plannedTrajectory_;
  }
  /**
   * <code>repeated .SimulationController.PlannedTrajectory plannedTrajectory = 2;</code>
   */
  public java.util.List<? extends protobuf.PlannedTrajectoryOrBuilder> 
      getPlannedTrajectoryOrBuilderList() {
    return plannedTrajectory_;
  }
  /**
   * <code>repeated .SimulationController.PlannedTrajectory plannedTrajectory = 2;</code>
   */
  public int getPlannedTrajectoryCount() {
    return plannedTrajectory_.size();
  }
  /**
   * <code>repeated .SimulationController.PlannedTrajectory plannedTrajectory = 2;</code>
   */
  public protobuf.PlannedTrajectory getPlannedTrajectory(int index) {
    return plannedTrajectory_.get(index);
  }
  /**
   * <code>repeated .SimulationController.PlannedTrajectory plannedTrajectory = 2;</code>
   */
  public protobuf.PlannedTrajectoryOrBuilder getPlannedTrajectoryOrBuilder(
      int index) {
    return plannedTrajectory_.get(index);
  }

  public static final int FRAMES_FIELD_NUMBER = 3;
  private java.util.List<protobuf.SimulationDataFrame> frames_;
  /**
   * <code>repeated .SimulationController.SimulationDataFrame frames = 3;</code>
   */
  public java.util.List<protobuf.SimulationDataFrame> getFramesList() {
    return frames_;
  }
  /**
   * <code>repeated .SimulationController.SimulationDataFrame frames = 3;</code>
   */
  public java.util.List<? extends protobuf.SimulationDataFrameOrBuilder> 
      getFramesOrBuilderList() {
    return frames_;
  }
  /**
   * <code>repeated .SimulationController.SimulationDataFrame frames = 3;</code>
   */
  public int getFramesCount() {
    return frames_.size();
  }
  /**
   * <code>repeated .SimulationController.SimulationDataFrame frames = 3;</code>
   */
  public protobuf.SimulationDataFrame getFrames(int index) {
    return frames_.get(index);
  }
  /**
   * <code>repeated .SimulationController.SimulationDataFrame frames = 3;</code>
   */
  public protobuf.SimulationDataFrameOrBuilder getFramesOrBuilder(
      int index) {
    return frames_.get(index);
  }

  private byte memoizedIsInitialized = -1;
  public final boolean isInitialized() {
    byte isInitialized = memoizedIsInitialized;
    if (isInitialized == 1) return true;
    if (isInitialized == 0) return false;

    memoizedIsInitialized = 1;
    return true;
  }

  public void writeTo(com.google.protobuf.CodedOutputStream output)
                      throws java.io.IOException {
    if (!getVehicleIDBytes().isEmpty()) {
      com.google.protobuf.GeneratedMessageV3.writeString(output, 1, vehicleID_);
    }
    for (int i = 0; i < plannedTrajectory_.size(); i++) {
      output.writeMessage(2, plannedTrajectory_.get(i));
    }
    for (int i = 0; i < frames_.size(); i++) {
      output.writeMessage(3, frames_.get(i));
    }
    unknownFields.writeTo(output);
  }

  public int getSerializedSize() {
    int size = memoizedSize;
    if (size != -1) return size;

    size = 0;
    if (!getVehicleIDBytes().isEmpty()) {
      size += com.google.protobuf.GeneratedMessageV3.computeStringSize(1, vehicleID_);
    }
    for (int i = 0; i < plannedTrajectory_.size(); i++) {
      size += com.google.protobuf.CodedOutputStream
        .computeMessageSize(2, plannedTrajectory_.get(i));
    }
    for (int i = 0; i < frames_.size(); i++) {
      size += com.google.protobuf.CodedOutputStream
        .computeMessageSize(3, frames_.get(i));
    }
    size += unknownFields.getSerializedSize();
    memoizedSize = size;
    return size;
  }

  @java.lang.Override
  public boolean equals(final java.lang.Object obj) {
    if (obj == this) {
     return true;
    }
    if (!(obj instanceof protobuf.VehicleSimulationDataFrame)) {
      return super.equals(obj);
    }
    protobuf.VehicleSimulationDataFrame other = (protobuf.VehicleSimulationDataFrame) obj;

    boolean result = true;
    result = result && getVehicleID()
        .equals(other.getVehicleID());
    result = result && getPlannedTrajectoryList()
        .equals(other.getPlannedTrajectoryList());
    result = result && getFramesList()
        .equals(other.getFramesList());
    result = result && unknownFields.equals(other.unknownFields);
    return result;
  }

  @java.lang.Override
  public int hashCode() {
    if (memoizedHashCode != 0) {
      return memoizedHashCode;
    }
    int hash = 41;
    hash = (19 * hash) + getDescriptor().hashCode();
    hash = (37 * hash) + VEHICLEID_FIELD_NUMBER;
    hash = (53 * hash) + getVehicleID().hashCode();
    if (getPlannedTrajectoryCount() > 0) {
      hash = (37 * hash) + PLANNEDTRAJECTORY_FIELD_NUMBER;
      hash = (53 * hash) + getPlannedTrajectoryList().hashCode();
    }
    if (getFramesCount() > 0) {
      hash = (37 * hash) + FRAMES_FIELD_NUMBER;
      hash = (53 * hash) + getFramesList().hashCode();
    }
    hash = (29 * hash) + unknownFields.hashCode();
    memoizedHashCode = hash;
    return hash;
  }

  public static protobuf.VehicleSimulationDataFrame parseFrom(
      java.nio.ByteBuffer data)
      throws com.google.protobuf.InvalidProtocolBufferException {
    return PARSER.parseFrom(data);
  }
  public static protobuf.VehicleSimulationDataFrame parseFrom(
      java.nio.ByteBuffer data,
      com.google.protobuf.ExtensionRegistryLite extensionRegistry)
      throws com.google.protobuf.InvalidProtocolBufferException {
    return PARSER.parseFrom(data, extensionRegistry);
  }
  public static protobuf.VehicleSimulationDataFrame parseFrom(
      com.google.protobuf.ByteString data)
      throws com.google.protobuf.InvalidProtocolBufferException {
    return PARSER.parseFrom(data);
  }
  public static protobuf.VehicleSimulationDataFrame parseFrom(
      com.google.protobuf.ByteString data,
      com.google.protobuf.ExtensionRegistryLite extensionRegistry)
      throws com.google.protobuf.InvalidProtocolBufferException {
    return PARSER.parseFrom(data, extensionRegistry);
  }
  public static protobuf.VehicleSimulationDataFrame parseFrom(byte[] data)
      throws com.google.protobuf.InvalidProtocolBufferException {
    return PARSER.parseFrom(data);
  }
  public static protobuf.VehicleSimulationDataFrame parseFrom(
      byte[] data,
      com.google.protobuf.ExtensionRegistryLite extensionRegistry)
      throws com.google.protobuf.InvalidProtocolBufferException {
    return PARSER.parseFrom(data, extensionRegistry);
  }
  public static protobuf.VehicleSimulationDataFrame parseFrom(java.io.InputStream input)
      throws java.io.IOException {
    return com.google.protobuf.GeneratedMessageV3
        .parseWithIOException(PARSER, input);
  }
  public static protobuf.VehicleSimulationDataFrame parseFrom(
      java.io.InputStream input,
      com.google.protobuf.ExtensionRegistryLite extensionRegistry)
      throws java.io.IOException {
    return com.google.protobuf.GeneratedMessageV3
        .parseWithIOException(PARSER, input, extensionRegistry);
  }
  public static protobuf.VehicleSimulationDataFrame parseDelimitedFrom(java.io.InputStream input)
      throws java.io.IOException {
    return com.google.protobuf.GeneratedMessageV3
        .parseDelimitedWithIOException(PARSER, input);
  }
  public static protobuf.VehicleSimulationDataFrame parseDelimitedFrom(
      java.io.InputStream input,
      com.google.protobuf.ExtensionRegistryLite extensionRegistry)
      throws java.io.IOException {
    return com.google.protobuf.GeneratedMessageV3
        .parseDelimitedWithIOException(PARSER, input, extensionRegistry);
  }
  public static protobuf.VehicleSimulationDataFrame parseFrom(
      com.google.protobuf.CodedInputStream input)
      throws java.io.IOException {
    return com.google.protobuf.GeneratedMessageV3
        .parseWithIOException(PARSER, input);
  }
  public static protobuf.VehicleSimulationDataFrame parseFrom(
      com.google.protobuf.CodedInputStream input,
      com.google.protobuf.ExtensionRegistryLite extensionRegistry)
      throws java.io.IOException {
    return com.google.protobuf.GeneratedMessageV3
        .parseWithIOException(PARSER, input, extensionRegistry);
  }

  public Builder newBuilderForType() { return newBuilder(); }
  public static Builder newBuilder() {
    return DEFAULT_INSTANCE.toBuilder();
  }
  public static Builder newBuilder(protobuf.VehicleSimulationDataFrame prototype) {
    return DEFAULT_INSTANCE.toBuilder().mergeFrom(prototype);
  }
  public Builder toBuilder() {
    return this == DEFAULT_INSTANCE
        ? new Builder() : new Builder().mergeFrom(this);
  }

  @java.lang.Override
  protected Builder newBuilderForType(
      com.google.protobuf.GeneratedMessageV3.BuilderParent parent) {
    Builder builder = new Builder(parent);
    return builder;
  }
  /**
   * Protobuf type {@code SimulationController.VehicleSimulationDataFrame}
   */
  public static final class Builder extends
      com.google.protobuf.GeneratedMessageV3.Builder<Builder> implements
      // @@protoc_insertion_point(builder_implements:SimulationController.VehicleSimulationDataFrame)
      protobuf.VehicleSimulationDataFrameOrBuilder {
    public static final com.google.protobuf.Descriptors.Descriptor
        getDescriptor() {
      return protobuf.SimulationControllerProto.internal_static_SimulationController_VehicleSimulationDataFrame_descriptor;
    }

    protected com.google.protobuf.GeneratedMessageV3.FieldAccessorTable
        internalGetFieldAccessorTable() {
      return protobuf.SimulationControllerProto.internal_static_SimulationController_VehicleSimulationDataFrame_fieldAccessorTable
          .ensureFieldAccessorsInitialized(
              protobuf.VehicleSimulationDataFrame.class, protobuf.VehicleSimulationDataFrame.Builder.class);
    }

    // Construct using protobuf.VehicleSimulationDataFrame.newBuilder()
    private Builder() {
      maybeForceBuilderInitialization();
    }

    private Builder(
        com.google.protobuf.GeneratedMessageV3.BuilderParent parent) {
      super(parent);
      maybeForceBuilderInitialization();
    }
    private void maybeForceBuilderInitialization() {
      if (com.google.protobuf.GeneratedMessageV3
              .alwaysUseFieldBuilders) {
        getPlannedTrajectoryFieldBuilder();
        getFramesFieldBuilder();
      }
    }
    public Builder clear() {
      super.clear();
      vehicleID_ = "";

      if (plannedTrajectoryBuilder_ == null) {
        plannedTrajectory_ = java.util.Collections.emptyList();
        bitField0_ = (bitField0_ & ~0x00000002);
      } else {
        plannedTrajectoryBuilder_.clear();
      }
      if (framesBuilder_ == null) {
        frames_ = java.util.Collections.emptyList();
        bitField0_ = (bitField0_ & ~0x00000004);
      } else {
        framesBuilder_.clear();
      }
      return this;
    }

    public com.google.protobuf.Descriptors.Descriptor
        getDescriptorForType() {
      return protobuf.SimulationControllerProto.internal_static_SimulationController_VehicleSimulationDataFrame_descriptor;
    }

    public protobuf.VehicleSimulationDataFrame getDefaultInstanceForType() {
      return protobuf.VehicleSimulationDataFrame.getDefaultInstance();
    }

    public protobuf.VehicleSimulationDataFrame build() {
      protobuf.VehicleSimulationDataFrame result = buildPartial();
      if (!result.isInitialized()) {
        throw newUninitializedMessageException(result);
      }
      return result;
    }

    public protobuf.VehicleSimulationDataFrame buildPartial() {
      protobuf.VehicleSimulationDataFrame result = new protobuf.VehicleSimulationDataFrame(this);
      int from_bitField0_ = bitField0_;
      int to_bitField0_ = 0;
      result.vehicleID_ = vehicleID_;
      if (plannedTrajectoryBuilder_ == null) {
        if (((bitField0_ & 0x00000002) == 0x00000002)) {
          plannedTrajectory_ = java.util.Collections.unmodifiableList(plannedTrajectory_);
          bitField0_ = (bitField0_ & ~0x00000002);
        }
        result.plannedTrajectory_ = plannedTrajectory_;
      } else {
        result.plannedTrajectory_ = plannedTrajectoryBuilder_.build();
      }
      if (framesBuilder_ == null) {
        if (((bitField0_ & 0x00000004) == 0x00000004)) {
          frames_ = java.util.Collections.unmodifiableList(frames_);
          bitField0_ = (bitField0_ & ~0x00000004);
        }
        result.frames_ = frames_;
      } else {
        result.frames_ = framesBuilder_.build();
      }
      result.bitField0_ = to_bitField0_;
      onBuilt();
      return result;
    }

    public Builder clone() {
      return (Builder) super.clone();
    }
    public Builder setField(
        com.google.protobuf.Descriptors.FieldDescriptor field,
        java.lang.Object value) {
      return (Builder) super.setField(field, value);
    }
    public Builder clearField(
        com.google.protobuf.Descriptors.FieldDescriptor field) {
      return (Builder) super.clearField(field);
    }
    public Builder clearOneof(
        com.google.protobuf.Descriptors.OneofDescriptor oneof) {
      return (Builder) super.clearOneof(oneof);
    }
    public Builder setRepeatedField(
        com.google.protobuf.Descriptors.FieldDescriptor field,
        int index, java.lang.Object value) {
      return (Builder) super.setRepeatedField(field, index, value);
    }
    public Builder addRepeatedField(
        com.google.protobuf.Descriptors.FieldDescriptor field,
        java.lang.Object value) {
      return (Builder) super.addRepeatedField(field, value);
    }
    public Builder mergeFrom(com.google.protobuf.Message other) {
      if (other instanceof protobuf.VehicleSimulationDataFrame) {
        return mergeFrom((protobuf.VehicleSimulationDataFrame)other);
      } else {
        super.mergeFrom(other);
        return this;
      }
    }

    public Builder mergeFrom(protobuf.VehicleSimulationDataFrame other) {
      if (other == protobuf.VehicleSimulationDataFrame.getDefaultInstance()) return this;
      if (!other.getVehicleID().isEmpty()) {
        vehicleID_ = other.vehicleID_;
        onChanged();
      }
      if (plannedTrajectoryBuilder_ == null) {
        if (!other.plannedTrajectory_.isEmpty()) {
          if (plannedTrajectory_.isEmpty()) {
            plannedTrajectory_ = other.plannedTrajectory_;
            bitField0_ = (bitField0_ & ~0x00000002);
          } else {
            ensurePlannedTrajectoryIsMutable();
            plannedTrajectory_.addAll(other.plannedTrajectory_);
          }
          onChanged();
        }
      } else {
        if (!other.plannedTrajectory_.isEmpty()) {
          if (plannedTrajectoryBuilder_.isEmpty()) {
            plannedTrajectoryBuilder_.dispose();
            plannedTrajectoryBuilder_ = null;
            plannedTrajectory_ = other.plannedTrajectory_;
            bitField0_ = (bitField0_ & ~0x00000002);
            plannedTrajectoryBuilder_ = 
              com.google.protobuf.GeneratedMessageV3.alwaysUseFieldBuilders ?
                 getPlannedTrajectoryFieldBuilder() : null;
          } else {
            plannedTrajectoryBuilder_.addAllMessages(other.plannedTrajectory_);
          }
        }
      }
      if (framesBuilder_ == null) {
        if (!other.frames_.isEmpty()) {
          if (frames_.isEmpty()) {
            frames_ = other.frames_;
            bitField0_ = (bitField0_ & ~0x00000004);
          } else {
            ensureFramesIsMutable();
            frames_.addAll(other.frames_);
          }
          onChanged();
        }
      } else {
        if (!other.frames_.isEmpty()) {
          if (framesBuilder_.isEmpty()) {
            framesBuilder_.dispose();
            framesBuilder_ = null;
            frames_ = other.frames_;
            bitField0_ = (bitField0_ & ~0x00000004);
            framesBuilder_ = 
              com.google.protobuf.GeneratedMessageV3.alwaysUseFieldBuilders ?
                 getFramesFieldBuilder() : null;
          } else {
            framesBuilder_.addAllMessages(other.frames_);
          }
        }
      }
      this.mergeUnknownFields(other.unknownFields);
      onChanged();
      return this;
    }

    public final boolean isInitialized() {
      return true;
    }

    public Builder mergeFrom(
        com.google.protobuf.CodedInputStream input,
        com.google.protobuf.ExtensionRegistryLite extensionRegistry)
        throws java.io.IOException {
      protobuf.VehicleSimulationDataFrame parsedMessage = null;
      try {
        parsedMessage = PARSER.parsePartialFrom(input, extensionRegistry);
      } catch (com.google.protobuf.InvalidProtocolBufferException e) {
        parsedMessage = (protobuf.VehicleSimulationDataFrame) e.getUnfinishedMessage();
        throw e.unwrapIOException();
      } finally {
        if (parsedMessage != null) {
          mergeFrom(parsedMessage);
        }
      }
      return this;
    }
    private int bitField0_;

    private java.lang.Object vehicleID_ = "";
    /**
     * <code>string vehicleID = 1;</code>
     */
    public java.lang.String getVehicleID() {
      java.lang.Object ref = vehicleID_;
      if (!(ref instanceof java.lang.String)) {
        com.google.protobuf.ByteString bs =
            (com.google.protobuf.ByteString) ref;
        java.lang.String s = bs.toStringUtf8();
        vehicleID_ = s;
        return s;
      } else {
        return (java.lang.String) ref;
      }
    }
    /**
     * <code>string vehicleID = 1;</code>
     */
    public com.google.protobuf.ByteString
        getVehicleIDBytes() {
      java.lang.Object ref = vehicleID_;
      if (ref instanceof String) {
        com.google.protobuf.ByteString b = 
            com.google.protobuf.ByteString.copyFromUtf8(
                (java.lang.String) ref);
        vehicleID_ = b;
        return b;
      } else {
        return (com.google.protobuf.ByteString) ref;
      }
    }
    /**
     * <code>string vehicleID = 1;</code>
     */
    public Builder setVehicleID(
        java.lang.String value) {
      if (value == null) {
    throw new NullPointerException();
  }
  
      vehicleID_ = value;
      onChanged();
      return this;
    }
    /**
     * <code>string vehicleID = 1;</code>
     */
    public Builder clearVehicleID() {
      
      vehicleID_ = getDefaultInstance().getVehicleID();
      onChanged();
      return this;
    }
    /**
     * <code>string vehicleID = 1;</code>
     */
    public Builder setVehicleIDBytes(
        com.google.protobuf.ByteString value) {
      if (value == null) {
    throw new NullPointerException();
  }
  checkByteStringIsUtf8(value);
      
      vehicleID_ = value;
      onChanged();
      return this;
    }

    private java.util.List<protobuf.PlannedTrajectory> plannedTrajectory_ =
      java.util.Collections.emptyList();
    private void ensurePlannedTrajectoryIsMutable() {
      if (!((bitField0_ & 0x00000002) == 0x00000002)) {
        plannedTrajectory_ = new java.util.ArrayList<protobuf.PlannedTrajectory>(plannedTrajectory_);
        bitField0_ |= 0x00000002;
       }
    }

    private com.google.protobuf.RepeatedFieldBuilderV3<
        protobuf.PlannedTrajectory, protobuf.PlannedTrajectory.Builder, protobuf.PlannedTrajectoryOrBuilder> plannedTrajectoryBuilder_;

    /**
     * <code>repeated .SimulationController.PlannedTrajectory plannedTrajectory = 2;</code>
     */
    public java.util.List<protobuf.PlannedTrajectory> getPlannedTrajectoryList() {
      if (plannedTrajectoryBuilder_ == null) {
        return java.util.Collections.unmodifiableList(plannedTrajectory_);
      } else {
        return plannedTrajectoryBuilder_.getMessageList();
      }
    }
    /**
     * <code>repeated .SimulationController.PlannedTrajectory plannedTrajectory = 2;</code>
     */
    public int getPlannedTrajectoryCount() {
      if (plannedTrajectoryBuilder_ == null) {
        return plannedTrajectory_.size();
      } else {
        return plannedTrajectoryBuilder_.getCount();
      }
    }
    /**
     * <code>repeated .SimulationController.PlannedTrajectory plannedTrajectory = 2;</code>
     */
    public protobuf.PlannedTrajectory getPlannedTrajectory(int index) {
      if (plannedTrajectoryBuilder_ == null) {
        return plannedTrajectory_.get(index);
      } else {
        return plannedTrajectoryBuilder_.getMessage(index);
      }
    }
    /**
     * <code>repeated .SimulationController.PlannedTrajectory plannedTrajectory = 2;</code>
     */
    public Builder setPlannedTrajectory(
        int index, protobuf.PlannedTrajectory value) {
      if (plannedTrajectoryBuilder_ == null) {
        if (value == null) {
          throw new NullPointerException();
        }
        ensurePlannedTrajectoryIsMutable();
        plannedTrajectory_.set(index, value);
        onChanged();
      } else {
        plannedTrajectoryBuilder_.setMessage(index, value);
      }
      return this;
    }
    /**
     * <code>repeated .SimulationController.PlannedTrajectory plannedTrajectory = 2;</code>
     */
    public Builder setPlannedTrajectory(
        int index, protobuf.PlannedTrajectory.Builder builderForValue) {
      if (plannedTrajectoryBuilder_ == null) {
        ensurePlannedTrajectoryIsMutable();
        plannedTrajectory_.set(index, builderForValue.build());
        onChanged();
      } else {
        plannedTrajectoryBuilder_.setMessage(index, builderForValue.build());
      }
      return this;
    }
    /**
     * <code>repeated .SimulationController.PlannedTrajectory plannedTrajectory = 2;</code>
     */
    public Builder addPlannedTrajectory(protobuf.PlannedTrajectory value) {
      if (plannedTrajectoryBuilder_ == null) {
        if (value == null) {
          throw new NullPointerException();
        }
        ensurePlannedTrajectoryIsMutable();
        plannedTrajectory_.add(value);
        onChanged();
      } else {
        plannedTrajectoryBuilder_.addMessage(value);
      }
      return this;
    }
    /**
     * <code>repeated .SimulationController.PlannedTrajectory plannedTrajectory = 2;</code>
     */
    public Builder addPlannedTrajectory(
        int index, protobuf.PlannedTrajectory value) {
      if (plannedTrajectoryBuilder_ == null) {
        if (value == null) {
          throw new NullPointerException();
        }
        ensurePlannedTrajectoryIsMutable();
        plannedTrajectory_.add(index, value);
        onChanged();
      } else {
        plannedTrajectoryBuilder_.addMessage(index, value);
      }
      return this;
    }
    /**
     * <code>repeated .SimulationController.PlannedTrajectory plannedTrajectory = 2;</code>
     */
    public Builder addPlannedTrajectory(
        protobuf.PlannedTrajectory.Builder builderForValue) {
      if (plannedTrajectoryBuilder_ == null) {
        ensurePlannedTrajectoryIsMutable();
        plannedTrajectory_.add(builderForValue.build());
        onChanged();
      } else {
        plannedTrajectoryBuilder_.addMessage(builderForValue.build());
      }
      return this;
    }
    /**
     * <code>repeated .SimulationController.PlannedTrajectory plannedTrajectory = 2;</code>
     */
    public Builder addPlannedTrajectory(
        int index, protobuf.PlannedTrajectory.Builder builderForValue) {
      if (plannedTrajectoryBuilder_ == null) {
        ensurePlannedTrajectoryIsMutable();
        plannedTrajectory_.add(index, builderForValue.build());
        onChanged();
      } else {
        plannedTrajectoryBuilder_.addMessage(index, builderForValue.build());
      }
      return this;
    }
    /**
     * <code>repeated .SimulationController.PlannedTrajectory plannedTrajectory = 2;</code>
     */
    public Builder addAllPlannedTrajectory(
        java.lang.Iterable<? extends protobuf.PlannedTrajectory> values) {
      if (plannedTrajectoryBuilder_ == null) {
        ensurePlannedTrajectoryIsMutable();
        com.google.protobuf.AbstractMessageLite.Builder.addAll(
            values, plannedTrajectory_);
        onChanged();
      } else {
        plannedTrajectoryBuilder_.addAllMessages(values);
      }
      return this;
    }
    /**
     * <code>repeated .SimulationController.PlannedTrajectory plannedTrajectory = 2;</code>
     */
    public Builder clearPlannedTrajectory() {
      if (plannedTrajectoryBuilder_ == null) {
        plannedTrajectory_ = java.util.Collections.emptyList();
        bitField0_ = (bitField0_ & ~0x00000002);
        onChanged();
      } else {
        plannedTrajectoryBuilder_.clear();
      }
      return this;
    }
    /**
     * <code>repeated .SimulationController.PlannedTrajectory plannedTrajectory = 2;</code>
     */
    public Builder removePlannedTrajectory(int index) {
      if (plannedTrajectoryBuilder_ == null) {
        ensurePlannedTrajectoryIsMutable();
        plannedTrajectory_.remove(index);
        onChanged();
      } else {
        plannedTrajectoryBuilder_.remove(index);
      }
      return this;
    }
    /**
     * <code>repeated .SimulationController.PlannedTrajectory plannedTrajectory = 2;</code>
     */
    public protobuf.PlannedTrajectory.Builder getPlannedTrajectoryBuilder(
        int index) {
      return getPlannedTrajectoryFieldBuilder().getBuilder(index);
    }
    /**
     * <code>repeated .SimulationController.PlannedTrajectory plannedTrajectory = 2;</code>
     */
    public protobuf.PlannedTrajectoryOrBuilder getPlannedTrajectoryOrBuilder(
        int index) {
      if (plannedTrajectoryBuilder_ == null) {
        return plannedTrajectory_.get(index);  } else {
        return plannedTrajectoryBuilder_.getMessageOrBuilder(index);
      }
    }
    /**
     * <code>repeated .SimulationController.PlannedTrajectory plannedTrajectory = 2;</code>
     */
    public java.util.List<? extends protobuf.PlannedTrajectoryOrBuilder> 
         getPlannedTrajectoryOrBuilderList() {
      if (plannedTrajectoryBuilder_ != null) {
        return plannedTrajectoryBuilder_.getMessageOrBuilderList();
      } else {
        return java.util.Collections.unmodifiableList(plannedTrajectory_);
      }
    }
    /**
     * <code>repeated .SimulationController.PlannedTrajectory plannedTrajectory = 2;</code>
     */
    public protobuf.PlannedTrajectory.Builder addPlannedTrajectoryBuilder() {
      return getPlannedTrajectoryFieldBuilder().addBuilder(
          protobuf.PlannedTrajectory.getDefaultInstance());
    }
    /**
     * <code>repeated .SimulationController.PlannedTrajectory plannedTrajectory = 2;</code>
     */
    public protobuf.PlannedTrajectory.Builder addPlannedTrajectoryBuilder(
        int index) {
      return getPlannedTrajectoryFieldBuilder().addBuilder(
          index, protobuf.PlannedTrajectory.getDefaultInstance());
    }
    /**
     * <code>repeated .SimulationController.PlannedTrajectory plannedTrajectory = 2;</code>
     */
    public java.util.List<protobuf.PlannedTrajectory.Builder> 
         getPlannedTrajectoryBuilderList() {
      return getPlannedTrajectoryFieldBuilder().getBuilderList();
    }
    private com.google.protobuf.RepeatedFieldBuilderV3<
        protobuf.PlannedTrajectory, protobuf.PlannedTrajectory.Builder, protobuf.PlannedTrajectoryOrBuilder> 
        getPlannedTrajectoryFieldBuilder() {
      if (plannedTrajectoryBuilder_ == null) {
        plannedTrajectoryBuilder_ = new com.google.protobuf.RepeatedFieldBuilderV3<
            protobuf.PlannedTrajectory, protobuf.PlannedTrajectory.Builder, protobuf.PlannedTrajectoryOrBuilder>(
                plannedTrajectory_,
                ((bitField0_ & 0x00000002) == 0x00000002),
                getParentForChildren(),
                isClean());
        plannedTrajectory_ = null;
      }
      return plannedTrajectoryBuilder_;
    }

    private java.util.List<protobuf.SimulationDataFrame> frames_ =
      java.util.Collections.emptyList();
    private void ensureFramesIsMutable() {
      if (!((bitField0_ & 0x00000004) == 0x00000004)) {
        frames_ = new java.util.ArrayList<protobuf.SimulationDataFrame>(frames_);
        bitField0_ |= 0x00000004;
       }
    }

    private com.google.protobuf.RepeatedFieldBuilderV3<
        protobuf.SimulationDataFrame, protobuf.SimulationDataFrame.Builder, protobuf.SimulationDataFrameOrBuilder> framesBuilder_;

    /**
     * <code>repeated .SimulationController.SimulationDataFrame frames = 3;</code>
     */
    public java.util.List<protobuf.SimulationDataFrame> getFramesList() {
      if (framesBuilder_ == null) {
        return java.util.Collections.unmodifiableList(frames_);
      } else {
        return framesBuilder_.getMessageList();
      }
    }
    /**
     * <code>repeated .SimulationController.SimulationDataFrame frames = 3;</code>
     */
    public int getFramesCount() {
      if (framesBuilder_ == null) {
        return frames_.size();
      } else {
        return framesBuilder_.getCount();
      }
    }
    /**
     * <code>repeated .SimulationController.SimulationDataFrame frames = 3;</code>
     */
    public protobuf.SimulationDataFrame getFrames(int index) {
      if (framesBuilder_ == null) {
        return frames_.get(index);
      } else {
        return framesBuilder_.getMessage(index);
      }
    }
    /**
     * <code>repeated .SimulationController.SimulationDataFrame frames = 3;</code>
     */
    public Builder setFrames(
        int index, protobuf.SimulationDataFrame value) {
      if (framesBuilder_ == null) {
        if (value == null) {
          throw new NullPointerException();
        }
        ensureFramesIsMutable();
        frames_.set(index, value);
        onChanged();
      } else {
        framesBuilder_.setMessage(index, value);
      }
      return this;
    }
    /**
     * <code>repeated .SimulationController.SimulationDataFrame frames = 3;</code>
     */
    public Builder setFrames(
        int index, protobuf.SimulationDataFrame.Builder builderForValue) {
      if (framesBuilder_ == null) {
        ensureFramesIsMutable();
        frames_.set(index, builderForValue.build());
        onChanged();
      } else {
        framesBuilder_.setMessage(index, builderForValue.build());
      }
      return this;
    }
    /**
     * <code>repeated .SimulationController.SimulationDataFrame frames = 3;</code>
     */
    public Builder addFrames(protobuf.SimulationDataFrame value) {
      if (framesBuilder_ == null) {
        if (value == null) {
          throw new NullPointerException();
        }
        ensureFramesIsMutable();
        frames_.add(value);
        onChanged();
      } else {
        framesBuilder_.addMessage(value);
      }
      return this;
    }
    /**
     * <code>repeated .SimulationController.SimulationDataFrame frames = 3;</code>
     */
    public Builder addFrames(
        int index, protobuf.SimulationDataFrame value) {
      if (framesBuilder_ == null) {
        if (value == null) {
          throw new NullPointerException();
        }
        ensureFramesIsMutable();
        frames_.add(index, value);
        onChanged();
      } else {
        framesBuilder_.addMessage(index, value);
      }
      return this;
    }
    /**
     * <code>repeated .SimulationController.SimulationDataFrame frames = 3;</code>
     */
    public Builder addFrames(
        protobuf.SimulationDataFrame.Builder builderForValue) {
      if (framesBuilder_ == null) {
        ensureFramesIsMutable();
        frames_.add(builderForValue.build());
        onChanged();
      } else {
        framesBuilder_.addMessage(builderForValue.build());
      }
      return this;
    }
    /**
     * <code>repeated .SimulationController.SimulationDataFrame frames = 3;</code>
     */
    public Builder addFrames(
        int index, protobuf.SimulationDataFrame.Builder builderForValue) {
      if (framesBuilder_ == null) {
        ensureFramesIsMutable();
        frames_.add(index, builderForValue.build());
        onChanged();
      } else {
        framesBuilder_.addMessage(index, builderForValue.build());
      }
      return this;
    }
    /**
     * <code>repeated .SimulationController.SimulationDataFrame frames = 3;</code>
     */
    public Builder addAllFrames(
        java.lang.Iterable<? extends protobuf.SimulationDataFrame> values) {
      if (framesBuilder_ == null) {
        ensureFramesIsMutable();
        com.google.protobuf.AbstractMessageLite.Builder.addAll(
            values, frames_);
        onChanged();
      } else {
        framesBuilder_.addAllMessages(values);
      }
      return this;
    }
    /**
     * <code>repeated .SimulationController.SimulationDataFrame frames = 3;</code>
     */
    public Builder clearFrames() {
      if (framesBuilder_ == null) {
        frames_ = java.util.Collections.emptyList();
        bitField0_ = (bitField0_ & ~0x00000004);
        onChanged();
      } else {
        framesBuilder_.clear();
      }
      return this;
    }
    /**
     * <code>repeated .SimulationController.SimulationDataFrame frames = 3;</code>
     */
    public Builder removeFrames(int index) {
      if (framesBuilder_ == null) {
        ensureFramesIsMutable();
        frames_.remove(index);
        onChanged();
      } else {
        framesBuilder_.remove(index);
      }
      return this;
    }
    /**
     * <code>repeated .SimulationController.SimulationDataFrame frames = 3;</code>
     */
    public protobuf.SimulationDataFrame.Builder getFramesBuilder(
        int index) {
      return getFramesFieldBuilder().getBuilder(index);
    }
    /**
     * <code>repeated .SimulationController.SimulationDataFrame frames = 3;</code>
     */
    public protobuf.SimulationDataFrameOrBuilder getFramesOrBuilder(
        int index) {
      if (framesBuilder_ == null) {
        return frames_.get(index);  } else {
        return framesBuilder_.getMessageOrBuilder(index);
      }
    }
    /**
     * <code>repeated .SimulationController.SimulationDataFrame frames = 3;</code>
     */
    public java.util.List<? extends protobuf.SimulationDataFrameOrBuilder> 
         getFramesOrBuilderList() {
      if (framesBuilder_ != null) {
        return framesBuilder_.getMessageOrBuilderList();
      } else {
        return java.util.Collections.unmodifiableList(frames_);
      }
    }
    /**
     * <code>repeated .SimulationController.SimulationDataFrame frames = 3;</code>
     */
    public protobuf.SimulationDataFrame.Builder addFramesBuilder() {
      return getFramesFieldBuilder().addBuilder(
          protobuf.SimulationDataFrame.getDefaultInstance());
    }
    /**
     * <code>repeated .SimulationController.SimulationDataFrame frames = 3;</code>
     */
    public protobuf.SimulationDataFrame.Builder addFramesBuilder(
        int index) {
      return getFramesFieldBuilder().addBuilder(
          index, protobuf.SimulationDataFrame.getDefaultInstance());
    }
    /**
     * <code>repeated .SimulationController.SimulationDataFrame frames = 3;</code>
     */
    public java.util.List<protobuf.SimulationDataFrame.Builder> 
         getFramesBuilderList() {
      return getFramesFieldBuilder().getBuilderList();
    }
    private com.google.protobuf.RepeatedFieldBuilderV3<
        protobuf.SimulationDataFrame, protobuf.SimulationDataFrame.Builder, protobuf.SimulationDataFrameOrBuilder> 
        getFramesFieldBuilder() {
      if (framesBuilder_ == null) {
        framesBuilder_ = new com.google.protobuf.RepeatedFieldBuilderV3<
            protobuf.SimulationDataFrame, protobuf.SimulationDataFrame.Builder, protobuf.SimulationDataFrameOrBuilder>(
                frames_,
                ((bitField0_ & 0x00000004) == 0x00000004),
                getParentForChildren(),
                isClean());
        frames_ = null;
      }
      return framesBuilder_;
    }
    public final Builder setUnknownFields(
        final com.google.protobuf.UnknownFieldSet unknownFields) {
      return super.setUnknownFieldsProto3(unknownFields);
    }

    public final Builder mergeUnknownFields(
        final com.google.protobuf.UnknownFieldSet unknownFields) {
      return super.mergeUnknownFields(unknownFields);
    }


    // @@protoc_insertion_point(builder_scope:SimulationController.VehicleSimulationDataFrame)
  }

  // @@protoc_insertion_point(class_scope:SimulationController.VehicleSimulationDataFrame)
  private static final protobuf.VehicleSimulationDataFrame DEFAULT_INSTANCE;
  static {
    DEFAULT_INSTANCE = new protobuf.VehicleSimulationDataFrame();
  }

  public static protobuf.VehicleSimulationDataFrame getDefaultInstance() {
    return DEFAULT_INSTANCE;
  }

  private static final com.google.protobuf.Parser<VehicleSimulationDataFrame>
      PARSER = new com.google.protobuf.AbstractParser<VehicleSimulationDataFrame>() {
    public VehicleSimulationDataFrame parsePartialFrom(
        com.google.protobuf.CodedInputStream input,
        com.google.protobuf.ExtensionRegistryLite extensionRegistry)
        throws com.google.protobuf.InvalidProtocolBufferException {
      return new VehicleSimulationDataFrame(input, extensionRegistry);
    }
  };

  public static com.google.protobuf.Parser<VehicleSimulationDataFrame> parser() {
    return PARSER;
  }

  @java.lang.Override
  public com.google.protobuf.Parser<VehicleSimulationDataFrame> getParserForType() {
    return PARSER;
  }

  public protobuf.VehicleSimulationDataFrame getDefaultInstanceForType() {
    return DEFAULT_INSTANCE;
  }

}

